#pragma once

using namespace System;
using namespace System::Diagnostics;
using namespace System::Windows::Forms;

namespace Tool
{
	public ref class Process sealed abstract
	{
	//-------------------------------------------------------- vZXƃAhX֌W
	private:
		/// <summary>
		/// Ώۂ̃vZX𖼑O擾
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>vZXIuWFNg</returns>
		static System::Diagnostics::Process^ GetProcess(String^ processName)
		{
			cli::array<System::Diagnostics::Process^>^ processesByName = System::Diagnostics::Process::GetProcessesByName(processName);
			if (processesByName->Length == 0)
			{
				return nullptr;
			}
			return processesByName[0];
		}
	public:
		/// <summary>
		/// Ώۂ̃vZX̃x[XAhX擾
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>vZX̃AhXB㐔lIɈAꉞ|C^Ȃ̂IntPtr^B</returns>
		static IntPtr GetProcessBaseAddress(String^ processName)
		{
			System::Diagnostics::Process^ process = Process::GetProcess(processName);
			if (process == nullptr)
			{
				return IntPtr::Zero;
			}
			return process->MainModule->BaseAddress;
		}

		/// <summary>
		/// Ώۂ̃vZX̃Gg[|Cg擾
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>vZX̃Gg[|Cg̃AhXBʂBaseAdress0x1000́B</returns>
		static IntPtr GetProcessEntryPointAddress(String^ processName)
		{
			System::Diagnostics::Process^ process = Process::GetProcess(processName);
			if (process == nullptr)
			{
				return IntPtr::Zero;
			}
			return process->MainModule->EntryPointAddress;
		}


		//-------------------------------------------------------- t@Co[W֌W
	public:
		/// <summary>
		/// Ώۂ̃vZX̃t@Co[W4̐lœ
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>o[WӖS̐lB</returns>
		static int GetProcessFileVersionInt(String^ processName)
		{
			System::Diagnostics::Process^ process = Process::GetProcess(processName);
			if (process == nullptr)
			{
				return -1;
			}
			int fileMajorPart = process->MainModule->FileVersionInfo->FileMajorPart;
			int fileMinorPart = process->MainModule->FileVersionInfo->FileMinorPart;
			int fileBuildPart = process->MainModule->FileVersionInfo->FileBuildPart;
			int filePrivatePart = process->MainModule->FileVersionInfo->FilePrivatePart;
			return fileMajorPart * 1000 + fileMinorPart * 100 + fileBuildPart * 10 + filePrivatePart;
		}
		/// <summary>
		/// Ώۂ̃vZX̃t@Co[W𕶎Ŏ擾
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>o[W𕶎ŁB</returns>
		static String^ GetProcessFileVersion(String^ processName)
		{
			System::Diagnostics::Process^ process = Process::GetProcess(processName);
			if (process == nullptr)
			{
				return String::Empty;
			}
			return process->MainModule->FileVersionInfo->FileVersion;
		}
		/// <summary>
		///Ώۂ̃vZX̃v_NgƂẴo[W𕶎Ŏ擾
		/// </summary>
		/// <param name="processName">vZX̖OBʏt@CgqÓB</param>
		/// <returns>o[W𕶎ŁB</returns>
		static String^ GetProcessProductVersion(String^ processName)
		{
			System::Diagnostics::Process^ process = Process::GetProcess(processName);
			if (process == nullptr)
			{
				return nullptr;
			}
			return process->MainModule->FileVersionInfo->ProductVersion;
		}
	};
}