#pragma once

#pragma pack(1)

#include <cmath>

// ʂ̂RW^B
struct D3D_POSITION {
	D3D_POSITION(double _x, double _y, double _z) : x(_x),y(_y),z(_z) {}
	D3D_POSITION() : x(0),y(0),z(0) {}
	double x;
	double y;
	double z;

	D3D_POSITION& operator=(const D3D_POSITION& v);
    //rZq
	bool operator==(const D3D_POSITION& v) const;
	bool operator!=(const D3D_POSITION& v) const;
};

// ʂ̂RxNg^B
struct D3D_VECTOR {
	//oϐ
	double x;
	double y;
	double z;

	//RXgN^
	D3D_VECTOR();
	D3D_VECTOR(double x,double y,double z);
	D3D_VECTOR(D3D_POSITION pos);

	//Zq
	D3D_VECTOR& D3D_VECTOR::operator=(const D3D_VECTOR& v);
	//PZq
	D3D_VECTOR& operator+=(const D3D_VECTOR& v);
	D3D_VECTOR& operator-=(const D3D_VECTOR& v);
	D3D_VECTOR& operator*=(double k);
	D3D_VECTOR& operator/=(double k);
	D3D_VECTOR operator+()const;
	D3D_VECTOR operator-()const;
	//YZq
	double& operator[](int i);
    //rZq
	bool operator==(const D3D_VECTOR& v) const;
	bool operator!=(const D3D_VECTOR& v) const;
	//׃Ng̒
	double length()const;
	//K
	void normalize();
};
//xNgZ
//D3D_VECTOR+D3D_VECTOR
D3D_VECTOR operator+(const D3D_VECTOR& u,const D3D_VECTOR& v);
//D3D_VECTOR-D3D_VECTOR
D3D_VECTOR operator-(const D3D_VECTOR& u,const D3D_VECTOR& v);
//double*D3D_VECTOR
D3D_VECTOR operator*(double k,const  D3D_VECTOR& v);
//D3D_VECTOR*double
D3D_VECTOR operator*(const D3D_VECTOR& v,double k);
//D3D_VECTOR/double
D3D_VECTOR operator/(const D3D_VECTOR& v,double k);
// D3D_VECTOR*D3D_VECTOR
double operator*(const D3D_VECTOR& u,const D3D_VECTOR& v);
//O D3D_VECTOR%D3D_VECTOR
D3D_VECTOR operator%(const D3D_VECTOR& u,const D3D_VECTOR& v);
//2̃xNĝȂpx
double angle(const D3D_VECTOR& u,const D3D_VECTOR& v);
// Q_ԍW̍
D3D_VECTOR operator-(D3D_POSITION &p1, D3D_POSITION &p2);