#pragma once

#include <windows.h>


struct HEX_XY {
	int cols;
	int rows;
};


// wbNX̍WnBw x@ŒlĂB
struct HEX_POSITION {
	HEX_POSITION(double _x, double _y) : x(_x), y(_y) {}
	HEX_POSITION() : x(0), y(0) {}
	double x;
	double y;
};

// tB[h̕xNgBw x@ŒlĂB
struct HEX_VECTOR {
	HEX_VECTOR(double _x, double _y) : x(_x), y(_y) {}
	HEX_VECTOR() : x(0), y(0) {}
	double x;
	double y;
};

// tB[hWǔZBW`WãxNg߂̂ɁAʏAa|`邾낤B
HEX_VECTOR operator-(HEX_POSITION &p1, HEX_POSITION &p2);




#define GAMEDATASTRUCT_FIELD_HEX_COLS			41	// HEX̉̐
#define GAMEDATASTRUCT_FIELD_HEX_ROWS			24	// HEX̏c̐

const int GAMEDATASTRUCT_FIELD_HEX_CENTER_X = 20;
const int GAMEDATASTRUCT_FIELD_HEX_CENTER_Y = 12;

namespace FIELD_HEX_ROLE {
	enum { gO = 0x00, n = 0x1,  = 0x2, n = 0x3, rn = 0x4, X = 0x5, R = 0x6, R = 0x7, R = 0x8,  = 0x9,  = 0xA, C = 0xB,  = 0xB,  = 0xC /*QA*/ };
}

// 펞̃wbNX̖̃oCg
union NB6FIELD_HEX_ROLE {
	BYTE index[GAMEDATASTRUCT_FIELD_HEX_COLS * GAMEDATASTRUCT_FIELD_HEX_ROWS];				// oCg̃CfbNXƂĂ݂ꍇ
	struct {
		BYTE pos_x[GAMEDATASTRUCT_FIELD_HEX_COLS];				// 41A24sƂČꍇ;
	} pos_y[GAMEDATASTRUCT_FIELD_HEX_ROWS];
};

// 펞̃jbg̃}bṽ|WV
union NB6FIELD_HEX_UNIT_POS {
	BYTE index[GAMEDATASTRUCT_FIELD_HEX_COLS * GAMEDATASTRUCT_FIELD_HEX_ROWS];				// oCg̃CfbNXƂĂ݂ꍇ
	struct {
		BYTE pos_x[GAMEDATASTRUCT_FIELD_HEX_COLS];				// 41A24sƂČꍇ;
	} pos_y[GAMEDATASTRUCT_FIELD_HEX_ROWS];
};


// wbNXꏊ̃`bv̖(FIELD_HEX_ROLE)𓾂
int GetFieldHexRole(double x, double y);
int GetFieldHexRole(HEX_POSITION p);

// tɐݒ肷B(ƂĂAݒ肵ƂĂAGςȂ̂ŏ肭Ȃ)
void SetFieldHexRole(double x, double y, int eHexRole);
void SetFieldHexRole(HEX_POSITION p, int eHexRole);



// wbNXꏊ̍
int GetCastleHexHigh(double x, double y);
int GetCastleHexHigh(HEX_POSITION p);


// wbNXꏊ̍
int GetFieldHexHigh(double x, double y);
int GetFieldHexHigh(HEX_POSITION p);


#define GAMEDATASTRUCT_CASTLE_HEX_COLS			18	// UHEX̉̐
#define GAMEDATASTRUCT_CASTLE_HEX_ROWS			16	// UHEX̏c̐

const int GAMEDATASTRUCT_CASTLE_HEX_CENTER_X = 9;
const int GAMEDATASTRUCT_CASTLE_HEX_CENTER_Y = 8;

namespace CASTLE_HEX_ROLE {
	enum { gO = 0x00, n = 0x10, n = 0x11, On = 0x12, X = 0x13, x = 0x14, C = 0x14,  = 0x14, x = 0x15,  = 0x16,  = 0x17, J = 0x18, E = 0x19,  = 0x1A, { = 0x1B };
}

// 퓬ʂ̏wbNX̖̃oCg
union NB6CASTLE_HEX_ROLE {
	BYTE index[GAMEDATASTRUCT_CASTLE_HEX_COLS * GAMEDATASTRUCT_CASTLE_HEX_ROWS];				// oCg̃CfbNXƂĂ݂ꍇ
	struct {
		BYTE pos_x[GAMEDATASTRUCT_CASTLE_HEX_COLS];				// 18A16sƂČꍇ;
	} pos_y[GAMEDATASTRUCT_CASTLE_HEX_ROWS];
};

// 퓬ʂ̏wbNX̍̃oCg
union NB6CASTLE_HEX_HIGH {
	BYTE index[GAMEDATASTRUCT_CASTLE_HEX_COLS * GAMEDATASTRUCT_CASTLE_HEX_ROWS];				// oCg̃CfbNXƂĂ݂ꍇ
	struct {
		BYTE pos_x[GAMEDATASTRUCT_CASTLE_HEX_COLS];				// 18A16sƂČꍇ;
	} pos_y[GAMEDATASTRUCT_CASTLE_HEX_ROWS];
};

// Ũjbg̃}bṽ|WV
union NB6CASTLE_HEX_UNIT_POS {
	BYTE index[GAMEDATASTRUCT_CASTLE_HEX_COLS * GAMEDATASTRUCT_CASTLE_HEX_ROWS];				// oCg̃CfbNXƂĂ݂ꍇ
	struct {
		BYTE pos_x[GAMEDATASTRUCT_CASTLE_HEX_COLS];				// 18A16sƂČꍇ;
	} pos_y[GAMEDATASTRUCT_CASTLE_HEX_ROWS];
};


// wbNXꏊ̃`bv̖(CASTLE_HEX_ROLE)𓾂
int GetCastleHexRole(double x, double y);
int GetCastleHexRole(HEX_POSITION p);



// w̕hc̕ǂɂ̂H ȂꍇAp(x=0xFF, y=0xFF) ԂĂB
HEX_POSITION GetFieldHexUnitPos(int iBushouID);

// w̕hc̕ǂɂ̂H ȂꍇAp(x=0xFF, y=0xFF) ԂĂB
HEX_POSITION GetCastleHexUnitPos(int iBushouID);



// wbNXԊu̎擾Bp1p2܂ŉeړKv̂(SĂ̞e͍ŝƉ肷)
int getHexDistance(HEX_POSITION p1, HEX_POSITION p2);


// tB[hwbNX̍Wʂ̂RW(fJgEƓ)
D3D_POSITION FieldHexPos_To_WorldPos(HEX_POSITION p);

// ʂ̂RW(fJg)tB[hwbNX̍W
HEX_POSITION WorldPos_To_FieldHexPos(D3D_POSITION p);

// wbNX̍Wʂ̂RW(fJgEƓ)
D3D_POSITION CastleHexPos_To_WorldPos(HEX_POSITION p);

// ʂ̂RW(fJg)wbNX̍W
HEX_POSITION WorldPos_To_CastleHexPos(D3D_POSITION p);






namespace FIRE_HEX_ROLE {
	enum {  = 0x00,  = 0x01 };
}

// wbNXꏊ̃`bv̉
int GetFireHexRole(double x, double y);
int GetFireHexRole(HEX_POSITION p);





// wbNX̂`_Ƃa_̊Ԃɂ`bṽACԂB
vector<int> RoleArrayOfBetweenPosToPos(HEX_POSITION pos1, HEX_POSITION pos2);


