#include "GameDataStruct.h"

//----------------------------------------------------------------------------------

static char* nb6kanitypelist[GAMEDATASTRUCT_KANITYPE_NUM] = {
	"",
	"]",
	"",
	"]",
	"O",
	"]O",
	"lʏ",
	"lʉ",
	"]lʏ",
	"]lʉ",
	"܈ʏ",
	"܈ʉ",
	"]܈ʏ",
	"]܈ʉ",
	"Zʏ",
	"Zʉ",
	"]Zʏ",
	"]Zʉ",
	"ʏ",
	"ʉ",
	"]ʏ",
	"]ʉ",
	"ʏ",
};

char* getKaniTypeName(byte type) {
	return nb6kanitypelist[type];
}

// ʂ𕐏ɃA^b`BXʕĂꍇ́A̕w肵ւƃA^b`ςB
// \͒l̕ύX𔺂Bɖ߂ꍇ́A0xFFFFw肷邱ƁB
bool ReAttachKani(int iKaniID, int iNewBushouID) {
	if (!(0 <= iKaniID && iKaniID < GAMEDATASTRUCT_KANI_NUM)) {
		return false;
	}

	int iOldBushouID = nb6kani[iKaniID].attach - 1;
	// {lBKvȂB
	if (iOldBushouID == iNewBushouID) {
		return true;
	}
	// X삪ĂāAVȎw삾BKvȂB
	if (iOldBushouID >= 0xFFFE && iNewBushouID >= 0xFFFE) {
		return true;
	}


	// ̐̕\͂̑fl
	int iOldBushouPureCharm = 0;
	// Vw͐̕K̕łAł͂ȂB
	if (0 <= iOldBushouID && iOldBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		iOldBushouPureCharm = getBushouPureCharm(iOldBushouID);
		// sȔԍ͒ƂƂɂB
	}
	else {
		iOldBushouID = 0xFFFF;
	}

	int iNewBushouPureCharm = 0;
	// Vw͐̕K̕łAł͂ȂB
	if (0 <= iNewBushouID && iNewBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		iNewBushouPureCharm = getBushouPureCharm(iNewBushouID);

		// sȔԍ͒ƂƂɂB
	}
	else {
		iNewBushouID = 0xFFFF;
	}

	// Ώۂ̉ƕ̏҂ύXB
	nb6kani[iKaniID].attach = (iNewBushouID == 0xFFFF) ? 0xFFFF : (iNewBushouID + 1);

	// ͐̕K̕łAł͂ȂB
	if (0 <= iOldBushouID && iOldBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int iOldBushouCharmUpByKani = getBushouCharmUpByKani(iOldBushouID);
		nb6bushou[iOldBushouID].charm = iOldBushouPureCharm + iOldBushouCharmUpByKani;
	}

	// Vw͐̕K̕łAł͂ȂB
	if (0 <= iNewBushouID && iNewBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int iNewBushouCharmUpByKani = getBushouCharmUpByKani(iNewBushouID);
		nb6bushou[iNewBushouID].charm = iNewBushouPureCharm + iNewBushouCharmUpByKani;
	}

	return true;
}
